/* Generated by re2c 0.13.5 on Tue May 27 18:15:26 2014 */
#line 1 "lexer.cc.re"
#include <vector>
#include <cstdio>
#include <list>
#include <algorithm>
#include <unordered_map>

#include "lexer.hh"
#include "dprintf.hh"
#include "binding.hh"
#include "util.hh"

static const struct
{
    const char* string;
    QBtoken     token;
} ReservedWords_Const[] =
{
    { "ABS"        ,  ABS },
    { "ACCESS"     ,  ACCESS },
    { "ALIAS"      ,  ALIAS },
    { "AND"        ,  AND },
    { "ANY"        ,  ANY },
    { "APPEND"     ,  APPEND },
    { "AS"         ,  AS },
    { "ASC"        ,  ASC },
    { "ATN"        ,  ATN },
    { "BASE"       ,  BASE },
    { "BEEP"       ,  BEEP },
    { "BINARY"     ,  BINARY },
    { "BYVAL"      ,  BYVAL },
    { "CALL"       ,  CALL },
    { "CASE"       ,  CASE },
    { "CDBL"       ,  CDBL },
    { "CDECL"      ,  CDECL },
    { "CHDIR"      ,  CHDIR },
    { "CHR$"       ,  CHR_S },
    { "CINT"       ,  CINT },
    { "CIRCLE"     ,  CIRCLE },
    { "CLEAR"      ,  CLEAR },
    { "CLNG"       ,  CLNG },
    { "CLOSE"      ,  CLOSE },
    { "CLS"        ,  CLS },
    { "COLOR"      ,  COLOR },
    { "COMMAND$"   ,  COMMAND_S },
    { "COMMON"     ,  COMMON },
    { "CONST"      ,  CONST },
    { "COS"        ,  COS },
    { "CSNG"       ,  CSNG },
    { "CSRLIN"     ,  CSRLIN },
    { "CVD"        ,  CVD },
    { "CVI"        ,  CVI },
    { "CVL"        ,  CVL },
    { "CVS"        ,  CVS },
    { "DATE$"      ,  DATE_S },
    { "DECLARE"    ,  DECLARE },
    { "DEF"        ,  DEF },
    { "DIM"        ,  DIM },
    { "DO"         ,  DO },
    { "DOUBLE"     ,  DOUBLE },
    { "DRAW"       ,  DRAW },
    { "ELSE"       ,  ELSE },
    { "ELSEIF"     ,  ELSEIF },
    { "END"        ,  END },
    { "ENVIRON$"   ,  ENVIRON_S /* also takes strings */ },
    { "EQV"        ,  EQV },
    { "ERASE"      ,  ERASE },
    { "ERL"        ,  ERL },
    { "ERR"        ,  ERR },
    { "ERROR"      ,  ERROR },
    { "EXIT"       ,  EXIT },
    { "EXP"        ,  EXP },
    { "FIELD"      ,  FIELD },
    { "FILEATTR"   ,  FILEATTR /* two args */ },
    { "FILES"      ,  FILES },
    { "FIX"        ,  FIX },
    { "FOR"        ,  FOR },
    { "FRE"        ,  FRE       /* also takes strings */ },
    { "FREEFILE"   ,  FREEFILE },
    { "FUNCTION"   ,  FUNCTION },
    { "GET"        ,  GET },
    { "GOSUB"      ,  GOSUB },
    { "GOTO"       ,  GOTO },
    { "HEX$"       ,  HEX_S },
    { "IF"         ,  IF },
    { "IMP"        ,  IMP },
    { "INKEY$"     ,  INKEY_S },
    { "INP"        ,  INP },
    { "INPUT"      ,  INPUT },
    { "INPUT$"     ,  INPUT_S },
    { "INSTR"      ,  INSTR },
    { "INT"        ,  INT },
    { "INTEGER"    ,  INTEGER },
    { "IS"         ,  IS },
    { "KEY"        ,  KEY },
    { "KILL"       ,  KILL },
    { "LBOUND"     ,  LBOUND /* array */ },
    { "LCASE$"     ,  LCASE_S },
    { "LEFT$"      ,  LEFT_S },
    { "LEN"        ,  LEN },
    { "LET"        ,  LET },
    { "LINE"       ,  LINE },
    { "LIST"       ,  LIST },
    { "LOC"        ,  LOC },
    { "LOCATE"     ,  LOCATE },
    { "LOCK"       ,  LOCK },
    { "LOF"        ,  LOF },
    { "LOG"        ,  LOG },
    { "LONG"       ,  LONG },
    { "LOOP"       ,  LOOP },
    { "LPOS"       ,  LPOS },
    { "LPRINT"     ,  LPRINT },
    { "LSET"       ,  LSET },
    { "LTRIM$"     ,  LTRIM_S },
    { "MID$"       ,  MID_S },
    { "MKD$"       ,  MKD_S },
    { "MKDIR"      ,  MKDIR },
    { "MKI$"       ,  MKI_S },
    { "MKL$"       ,  MKL_S },
    { "MKS$"       ,  MKS_S },
    { "MOD"        ,  MOD },
    { "NEXT"       ,  NEXT },
    { "NOISE"      ,  NOISE },
    { "NOT"        ,  NOT },
    { "OCT$"       ,  OCT_S },
    { "OFF"        ,  OFF },
    { "ON"         ,  ON },
    { "OPEN"       ,  OPEN },
    { "OPTION"     ,  OPTION },
    { "OR"         ,  OR },
    { "OUT"        ,  OUT },
    { "OUTPUT"     ,  OUTPUT },
    { "PAINT"      ,  PAINT },
    { "PALETTE"    ,  PALETTE },
    { "PEEK"       ,  PEEK },
    { "PLAY"       ,  PLAY },
    { "PMAP"       ,  PMAP },
    { "POINT"      ,  POINT /* gfx */ },
    { "POKE"       ,  POKE },
    { "POS"        ,  POS },
    { "PRESET"     ,  PRESET },
    { "PRINT"      ,  PRINT },
    { "PSET"       ,  PSET },
    { "PUT"        ,  PUT },
    { "RANDOM"     ,  RANDOM },
    { "RANDOMIZE"  ,  RANDOMIZE },
    { "READ"       ,  READ },
    { "REDIM"      ,  REDIM },
    { "RESTORE"    ,  RESTORE },
    { "RESUME"     ,  RESUME },
    { "RETURN"     ,  RETURN },
    { "RIGHT$"     ,  RIGHT_S },
    { "RMDIR"      ,  RMDIR },
    { "RND"        ,  RND },
    { "RSET"       ,  RSET },
    { "RTRIM$"     ,  RTRIM_S },
    { "SCREEN"     ,  SCREEN },
    { "SEEK"       ,  SEEK },
    { "SEG"        ,  SEG },
    { "SELECT"     ,  SELECT },
    { "SGN"        ,  SGN },
    { "SHARED"     ,  SHARED },
    { "SHELL"      ,  SHELL },
    { "SIN"        ,  SIN },
    { "SINGLE"     ,  SINGLE },
    { "SLEEP"      ,  SLEEP },
    { "SOUND"      ,  SOUND },
    { "SPACE$"     ,  SPACE_S },
    { "SPC"        ,  SPC },
    { "SQR"        ,  SQR },
    { "STATIC"     ,  STATIC },
    { "STEP"       ,  STEP },
    { "STOP"       ,  STOP },
    { "STR$"       ,  STR_S },
    { "STRING"     ,  STRING },
    { "STRING$"    ,  STRING_S },
    { "SUB"        ,  SUB },
    { "SWAP"       ,  SWAP },
    { "SYSTEM"     ,  SYSTEM },
    { "TAB"        ,  TAB },
    { "TAN"        ,  TAN },
    { "THEN"       ,  THEN },
    { "TIME$"      ,  TIME_S },
    { "TIMER"      ,  TIMER },
    { "TO"         ,  TO },
    { "TYPE"       ,  TYPE },
    { "UBOUND"     ,  UBOUND /* array */ },
    { "UCASE$"     ,  UCASE_S },
    { "UNTIL"      ,  UNTIL },
    { "USING"      ,  USING },
    { "VAL"        ,  VAL },
    { "VARPTR"     ,  VARPTR   /* any */ },
    { "VARPTR$"    ,  VARPTR_S /* any */ },
    { "VARSEG"     ,  VARSEG   /* any */ },
    { "VIEW"       ,  VIEW },
    { "WAIT"       ,  WAIT },
    { "WEND"       ,  WEND },
    { "WHILE"      ,  WHILE },
    { "WIDTH"      ,  WIDTH },
    { "WINDOW"     ,  WINDOW },
    { "WRITE"      ,  WRITE },
    { "XOR"        ,  XOR },
    { "_BIN$"      ,  qbcBIN_S },
    { "_BIT"       ,  qb64BIT },
    { "_BYTE"      ,  qb64BYTE },
    { "_DISPLAY"   ,  qb64DISPLAY },
    { "_DONTBLEND" ,  qb64DONTBLEND },
    { "_KEYDOWN"   ,  qb64KEYDOWN },
    { "_NEWIMAGE"  ,  qb64NEWIMAGE },
    { "_SNDBAL"    ,  qb64SNDBAL },
    { "_SNDCLOSE"  ,  qb64SNDCLOSE },
    { "_SNDCOPY"   ,  qb64SNDCOPY },
    { "_SNDOPEN"   ,  qb64SNDOPEN },
    { "_SNDPAUSE"  ,  qb64SNDPAUSE },
    { "_SNDPAUSED" ,  qb64SNDPAUSED },
    { "_SNDPLAYCOPY",  qb64SNDPLAYCOPY },
    { "_SNDPLAYING",  qb64SNDPLAYING },
    { "_SNDPLAY"   ,  qb64SNDPLAY },
    { "_SNDRATE"   ,  qb64SNDRATE },
    { "_SNDRAWDONE",  qb64SNDRAWDONE },
    { "_SNDRAWLEN" ,  qb64SNDRAWLEN },
    { "_SNDRAWOPEN",  qb64SNDRAWOPEN },
    { "_SNDRAW"    ,  qb64SNDRAW },
    { "_SNDSTOP"   ,  qb64SNDSTOP },
    { "_SHL"       ,  qbcSHL },
    { "_SHR"       ,  qbcSHR },
    { "_ASIN"      ,  qbcASIN },
    { "_ACOS"      ,  qbcACOS },
    { "_SINH"      ,  qbcSINH },
    { "_COSH"      ,  qbcCOSH },
    { "_TANH"      ,  qbcTANH },
    { "_ASINH"     ,  qbcASINH },
    { "_ACOSH"     ,  qbcACOSH },
    { "_ATANH"     ,  qbcATANH },
    { "_ATAN2"     ,  qbcATAN2 },
    { "_UNSIGNED"  ,  qb64UNSIGNED }
};
static const struct
{
    QBtoken token1, token2;
    QBtoken result;
} ComboTokens_Const[] =
{
    { DEF,SEG,       DEFSEG },
    { END,DEF,       ENDDEF },
    { END,FUNCTION,  ENDFUNCTION },
    { END,IF,        ENDIF },
    { END,SELECT,    ENDSELECT },
    { END,SUB,       ENDSUB },
    { END,TYPE,      ENDTYPE },
    { EXIT,DEF,      EXITDEF },
    { EXIT,DO,       EXITDO },
    { EXIT,FOR,      EXITFOR },
    { EXIT,FUNCTION, EXITFUNCTION },
    { EXIT,SUB,      EXITSUB },
    { LINE,INPUT,    LINE_INPUT },
    { ON,ERROR,      ON_ERROR },
    { ON,KEY,        ON_KEY },
    { ON,PLAY,       ON_PLAY },
    { ON,TIMER,      ON_TIMER },
    { PALETTE,USING, PALETTE_USING },
    { RESUME,NEXT,   RESUME_NEXT },
    { VIEW,PRINT,    VIEW_PRINT },
    { WIDTH,HASHSYM, WIDTH_F },
    { WIDTH,LPRINT,  WIDTH_LPRINT },
    { qb64UNSIGNED, INTEGER,  qb64UNSIGNEDINTEGER },
    { qb64UNSIGNED, LONG,     qb64UNSIGNEDLONG },
    { qb64UNSIGNED, qb64BIT,  qb64UNSIGNEDBIT },
    { qb64UNSIGNED, qb64BYTE, qb64UNSIGNEDBYTE },
};

struct saved_yy_context
{
    LexLocation loc;
    LexLocation loc_at_begin_of_token;
    std::FILE *fp;

    std::vector<char>::iterator buffer_limit;
    std::vector<char>::iterator buffer_cursor;
    std::vector<char>::iterator buffer_marker;
    std::vector<char>::iterator buffer_begin;
    std::vector<char> buffer;
    int condition;

    void InitBuffer()
    {
        buffer.clear();
        buffer_limit  = buffer.begin();
        buffer_cursor = buffer.begin();
        buffer_marker = buffer.begin();
        buffer_begin  = buffer.begin();
    }
    void Catchup()
    {
        buffer.erase(buffer.begin(), buffer_cursor);
        buffer_cursor = buffer.begin();
        buffer_marker = buffer.begin();
        buffer_begin  = buffer.begin();
        buffer_limit  = buffer.end();
        loc_at_begin_of_token = loc;
        FillBuffer(1);
    }
    void FillBuffer(unsigned n)
    {
        if( (buffer_limit-buffer_cursor) <= n)
            n -= (buffer_limit - buffer_cursor);
        if(!fp || !n) return;

        std::size_t cursor = buffer_cursor - buffer.begin();
        std::size_t marker = buffer_marker - buffer.begin();
        std::size_t begin  = buffer_begin  - buffer.begin();

        for(; n > 0; --n)
        {
            int c;
            do c = std::fgetc(fp); while(c == '\r' || c == '\32');
            if(c == '_')
            {
                do { c = std::fgetc(fp); } while(c == '\r' || c == '\32');
                if(c == '\n') c = std::fgetc(fp);
                else { ungetc(c, fp); c = '_'; }
            }
            if(c == EOF) { std::fclose(fp); fp = nullptr; break; }
            switch(c)
            {
                case '\n': ++loc.line; loc.col=1; break;
                case '\t': loc.col = 1 + ((loc.col+7)&~7); break;
                default: ++loc.col;
            }

            buffer.push_back( char(c) );
        }
        if(!fp)
        {
            buffer.push_back('\32');
        }
        buffer_cursor = buffer.begin() + cursor;
        buffer_marker = buffer.begin() + marker;
        buffer_begin  = buffer.begin() + begin;
        buffer_limit = buffer.end();
    }

    void Debug(int state, char ch)
    {
#ifdef LEXER_DEBUG
        dprintf(dp_lexer, "Lexer state%6d with '%c'; Row %d,column %d - Buffer(%4u/%2u): %s\n",
                state,ch, loc_at_begin_of_token.line,loc_at_begin_of_token.col,
                (unsigned)buffer.size(), (unsigned) Get().size(), Get().c_str());
#else
        state=state; ch=ch;
#endif
    }

    std::string Get(std::size_t skip_begin=0, std::size_t skip_end=0) const
    {
        return std::string( buffer_begin+skip_begin, buffer_cursor-skip_end );
    }
};

static saved_yy_context ctx;
static std::list<saved_yy_context> contexts;
static QBtoken prev_return = CRLF;
static std::unordered_map<std::string, QBtoken> ReservedWords;
static std::unordered_map<unsigned, std::unordered_map<unsigned, QBtoken>> ComboTokens;

LexerResult yylval;

void yyStartFile(std::FILE *fp, const char *name)
{
    ctx.loc.line     = 1;
    ctx.loc.col      = 1;
    ctx.loc.filename = name;
    /* .fp and .state are filled at $INCLUDE. */
    ctx.fp           = fp;
    ctx.condition    = -1;
    ctx.InitBuffer();

    if(ReservedWords.empty())
    {
        for(const auto& w: ReservedWords_Const)
            ReservedWords.insert( { w.string, w.token } );
        for(const auto& c: ComboTokens_Const)
            ComboTokens[c.token1].insert( { c.token2, c.result } );
    }

    SetDefVarType("ABCDEFGHIJKLMNOPQRSTUVWXYZ", "!"); // DEFSNG A-Z
}
bool yyEndFile(void)
{
    if(ctx.fp) std::fclose(ctx.fp);
    if(contexts.empty()) return false;

    ctx = std::move( contexts.back() );
    contexts.pop_back();
    return true;
}
const LexLocation& yyGetLocation()
{
     return ctx.loc_at_begin_of_token;
}

const std::string LexLocation::stringify() const
{
    return filename + ":" + std::to_string(line) + ":" + std::to_string(col);
}

void yyerror(const std::string& msg)
{
    yyerror(msg, ctx.loc);
}
void yyerror(const std::string& msg, const LexLocation& loc)
{
    dprintf(dp_errors, "\n%s: Error: %s\n", loc.stringify().c_str(), msg.c_str());
}

QBtoken LexerGetToken()
{
#line 444 "lexer.cc.re"

    enum YYCONDTYPE { yycINITIAL, yycDEFCMD, yycDATA, yycCOMMENT, yycCOMMENT_NOTMETA, yycINCLUDE };

    #define YYGETCONDITION()   ctx.condition
    #define YYSETCONDITION(n)  ctx.condition=(n)
    #define YYLIMIT   ctx.buffer_limit
    #define YYCURSOR  ctx.buffer_cursor
    #define YYMARKER  ctx.buffer_marker
    #define YYFILL(n) ctx.FillBuffer(n)

    static std::pair<LexerResult,QBtoken> pending;
    static bool token_pending = false;

    #define Return(val) do { prev_return = (QBtoken)(val); goto CheckReturn; } while(0)

    if(token_pending)
    {
        yylval = std::move( pending.first );
        token_pending = false;
        return pending.second;
    }

//RESCAN:
    ctx.Catchup();

#line 446 "lexer.cc"
{
    unsigned char yych;
    unsigned int yyaccept = 0;
    if (YYGETCONDITION() < 3) {
        if (YYGETCONDITION() < 1) {
            goto yyc_INITIAL;
        } else {
            if (YYGETCONDITION() < 2) {
                goto yyc_DEFCMD;
            } else {
                goto yyc_DATA;
            }
        }
    } else {
        if (YYGETCONDITION() < 4) {
            goto yyc_COMMENT;
        } else {
            if (YYGETCONDITION() < 5) {
                goto yyc_COMMENT_NOTMETA;
            } else {
                goto yyc_INCLUDE;
            }
        }
    }
/* *********************************** */
yyc_COMMENT:
    {
        static const unsigned char yybm[] = {
              0,   0,   0,   0,   0,   0,   0,   0, 
              0, 192,  64,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
            192,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
        };

        ctx.Debug(0, *YYCURSOR);
        if ((YYLIMIT - YYCURSOR) < 10) YYFILL(10);
        yych = (unsigned char)*YYCURSOR;
        if (yych <= 0x1A) {
            if (yych <= '\t') {
                if (yych >= '\t') goto yy4;
            } else {
                if (yych <= '\n') goto yy8;
                if (yych >= 0x1A) goto yy6;
            }
        } else {
            if (yych <= ' ') {
                if (yych >= ' ') goto yy4;
            } else {
                if (yych == '$') goto yy7;
            }
        }
        ctx.Debug(2, *YYCURSOR);
        ++YYCURSOR;
yy3:
        ctx.Debug(3, *YYCURSOR);
        YYSETCONDITION(yycCOMMENT_NOTMETA);
#line 673 "lexer.cc.re"
        goto yyc_COMMENT_NOTMETA;
#line 533 "lexer.cc"
yy4:
        ctx.Debug(4, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy48;
yy5:
        ctx.Debug(5, *YYCURSOR);
#line 671 "lexer.cc.re"
        { /* ignore spaces */ goto yyc_COMMENT; }
#line 543 "lexer.cc"
yy6:
        ctx.Debug(6, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy3;
yy7:
        ctx.Debug(7, *YYCURSOR);
        yyaccept = 0;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= 'S') {
            if (yych <= 'I') {
                if (yych == 'D') goto yy15;
                if (yych <= 'H') goto yy3;
                goto yy11;
            } else {
                if (yych == 'M') goto yy13;
                if (yych <= 'R') goto yy3;
                goto yy14;
            }
        } else {
            if (yych <= 'i') {
                if (yych == 'd') goto yy15;
                if (yych <= 'h') goto yy3;
                goto yy11;
            } else {
                if (yych <= 'm') {
                    if (yych <= 'l') goto yy3;
                    goto yy13;
                } else {
                    if (yych == 's') goto yy14;
                    goto yy3;
                }
            }
        }
yy8:
        ctx.Debug(8, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(9, *YYCURSOR);
        if (yybm[0+yych] & 64) {
            goto yy8;
        }
        ctx.Debug(10, *YYCURSOR);
        YYSETCONDITION(yycINITIAL);
#line 670 "lexer.cc.re"
        { Return (CRLF); }
#line 590 "lexer.cc"
yy11:
        ctx.Debug(11, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'N') goto yy36;
        if (yych == 'n') goto yy36;
yy12:
        ctx.Debug(12, *YYCURSOR);
        YYCURSOR = YYMARKER;
        goto yy3;
yy13:
        ctx.Debug(13, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'A') goto yy29;
        if (yych == 'a') goto yy29;
        goto yy12;
yy14:
        ctx.Debug(14, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'T') goto yy23;
        if (yych == 't') goto yy23;
        goto yy12;
yy15:
        ctx.Debug(15, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'Y') goto yy16;
        if (yych != 'y') goto yy12;
yy16:
        ctx.Debug(16, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'N') goto yy17;
        if (yych != 'n') goto yy12;
yy17:
        ctx.Debug(17, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'A') goto yy18;
        if (yych != 'a') goto yy12;
yy18:
        ctx.Debug(18, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'M') goto yy19;
        if (yych != 'm') goto yy12;
yy19:
        ctx.Debug(19, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'I') goto yy20;
        if (yych != 'i') goto yy12;
yy20:
        ctx.Debug(20, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'C') goto yy21;
        if (yych != 'c') goto yy12;
yy21:
        ctx.Debug(21, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(22, *YYCURSOR);
#line 662 "lexer.cc.re"
        { Return (metaDYNAMIC); }
#line 648 "lexer.cc"
yy23:
        ctx.Debug(23, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'A') goto yy24;
        if (yych != 'a') goto yy12;
yy24:
        ctx.Debug(24, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'T') goto yy25;
        if (yych != 't') goto yy12;
yy25:
        ctx.Debug(25, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'I') goto yy26;
        if (yych != 'i') goto yy12;
yy26:
        ctx.Debug(26, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'C') goto yy27;
        if (yych != 'c') goto yy12;
yy27:
        ctx.Debug(27, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(28, *YYCURSOR);
#line 663 "lexer.cc.re"
        { Return (metaSTATIC);  }
#line 675 "lexer.cc"
yy29:
        ctx.Debug(29, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'G') goto yy30;
        if (yych != 'g') goto yy12;
yy30:
        ctx.Debug(30, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'I') goto yy31;
        if (yych != 'i') goto yy12;
yy31:
        ctx.Debug(31, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'C') goto yy32;
        if (yych != 'c') goto yy12;
yy32:
        ctx.Debug(32, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'A') goto yy33;
        if (yych != 'a') goto yy12;
yy33:
        ctx.Debug(33, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'L') goto yy34;
        if (yych != 'l') goto yy12;
yy34:
        ctx.Debug(34, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(35, *YYCURSOR);
#line 664 "lexer.cc.re"
        {
    dprintf(dp_warnings, "There is no $MAGICAL keyword. It is qbc's term for arrays that are passed as function parameters, because they can be of any type and size, only determined at runtime. Any occurrence of $MAGICAL is treated just as a regular comment.\n");
                              ctx.Catchup();
                              goto yyc_COMMENT;
                            }
#line 711 "lexer.cc"
yy36:
        ctx.Debug(36, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'C') goto yy37;
        if (yych != 'c') goto yy12;
yy37:
        ctx.Debug(37, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'L') goto yy38;
        if (yych != 'l') goto yy12;
yy38:
        ctx.Debug(38, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'U') goto yy39;
        if (yych != 'u') goto yy12;
yy39:
        ctx.Debug(39, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'D') goto yy40;
        if (yych != 'd') goto yy12;
yy40:
        ctx.Debug(40, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'E') goto yy41;
        if (yych != 'e') goto yy12;
yy41:
        ctx.Debug(41, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych != ':') goto yy12;
        ctx.Debug(42, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == '\'') goto yy12;
        goto yy44;
yy43:
        ctx.Debug(43, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy44:
        ctx.Debug(44, *YYCURSOR);
        if (yybm[0+yych] & 128) {
            goto yy43;
        }
        if (yych != '\'') goto yy12;
        ctx.Debug(45, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(46, *YYCURSOR);
        YYSETCONDITION(yycINCLUDE);
#line 669 "lexer.cc.re"
        { ctx.Catchup(); goto yyc_INCLUDE; }
#line 762 "lexer.cc"
yy47:
        ctx.Debug(47, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy48:
        ctx.Debug(48, *YYCURSOR);
        if (yych == '\t') goto yy47;
        if (yych == ' ') goto yy47;
        goto yy5;
    }
/* *********************************** */
yyc_COMMENT_NOTMETA:
    {
        static const unsigned char yybm[] = {
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 192,  64, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            192, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
        };
        ctx.Debug(49, *YYCURSOR);
        if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
        yych = (unsigned char)*YYCURSOR;
        if (yych == '\n') goto yy54;
        if (yych == 0x1A) goto yy53;
        ctx.Debug(51, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy58;
yy52:
        ctx.Debug(52, *YYCURSOR);
#line 676 "lexer.cc.re"
        { /* Ignore longest possible blobs until newline */ goto yyc_COMMENT_NOTMETA; }
#line 824 "lexer.cc"
yy53:
        ctx.Debug(53, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy58;
yy54:
        ctx.Debug(54, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(55, *YYCURSOR);
        if (yybm[0+yych] & 64) {
            goto yy54;
        }
        ctx.Debug(56, *YYCURSOR);
        YYSETCONDITION(yycINITIAL);
#line 675 "lexer.cc.re"
        { Return (CRLF); }
#line 842 "lexer.cc"
yy57:
        ctx.Debug(57, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy58:
        ctx.Debug(58, *YYCURSOR);
        if (yybm[0+yych] & 128) {
            goto yy57;
        }
        goto yy52;
    }
/* *********************************** */
yyc_DATA:
    {
        static const unsigned char yybm[] = {
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 224,   0, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            224, 192, 128, 192, 192, 192, 192, 192, 
            192, 192, 192, 192,  64, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192,  64, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
            192, 192, 192, 192, 192, 192, 192, 192, 
        };
        ctx.Debug(59, *YYCURSOR);
        if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
        yych = (unsigned char)*YYCURSOR;
        if (yych <= ' ') {
            if (yych <= '\n') {
                if (yych <= 0x08) goto yy62;
                if (yych <= '\t') goto yy64;
            } else {
                if (yych == 0x1A) goto yy66;
                if (yych <= 0x1F) goto yy62;
                goto yy64;
            }
        } else {
            if (yych <= '+') {
                if (yych == '"') goto yy67;
                goto yy62;
            } else {
                if (yych <= ',') goto yy69;
                if (yych == ':') goto yy71;
                goto yy62;
            }
        }
        ctx.Debug(61, *YYCURSOR);
        YYCURSOR = YYMARKER;
        goto yy68;
yy62:
        ctx.Debug(62, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy79;
yy63:
        ctx.Debug(63, *YYCURSOR);
#line 650 "lexer.cc.re"
        {
    yylval.str = Trim(ctx.Get(0,0));
    //fprintf(stderr, "Data string (unquoted): '%s'\n", yylval.str.c_str());
    /* ltrim and rtrim the string - qb does that too. */
    Return (STRINGCONST);
  }
#line 931 "lexer.cc"
yy64:
        ctx.Debug(64, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy81;
yy65:
        ctx.Debug(65, *YYCURSOR);
#line 649 "lexer.cc.re"
        { /* Ignore space in DATA */ ctx.Catchup(); goto yyc_DATA; }
#line 941 "lexer.cc"
yy66:
        ctx.Debug(66, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy79;
yy67:
        ctx.Debug(67, *YYCURSOR);
        yyaccept = 0;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        goto yy75;
yy68:
        ctx.Debug(68, *YYCURSOR);
        YYSETCONDITION(yycINITIAL);
#line 657 "lexer.cc.re"
        { YYCURSOR = ctx.buffer_begin; goto yyc_INITIAL; /* end of data */ }
#line 956 "lexer.cc"
yy69:
        ctx.Debug(69, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy73;
yy70:
        ctx.Debug(70, *YYCURSOR);
#line 656 "lexer.cc.re"
        { Return (COMMA); }
#line 966 "lexer.cc"
yy71:
        ctx.Debug(71, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy68;
yy72:
        ctx.Debug(72, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy73:
        ctx.Debug(73, *YYCURSOR);
        if (yybm[0+yych] & 32) {
            goto yy72;
        }
        goto yy70;
yy74:
        ctx.Debug(74, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy75:
        ctx.Debug(75, *YYCURSOR);
        if (yybm[0+yych] & 64) {
            goto yy74;
        }
        ctx.Debug(76, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(77, *YYCURSOR);
#line 642 "lexer.cc.re"
        {
    yylval.str = ctx.Get(1,1); // Skip '#' and remove '"'
    //fprintf(stderr, "Data string (quoted): '%s'\n", yylval.str.c_str());
    if(YYCURSOR[-1] == '\n') --YYCURSOR; // unput linefeed
    Return (STRINGCONST);
  }
#line 1002 "lexer.cc"
yy78:
        ctx.Debug(78, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy79:
        ctx.Debug(79, *YYCURSOR);
        if (yybm[0+yych] & 128) {
            goto yy78;
        }
        goto yy63;
yy80:
        ctx.Debug(80, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy81:
        ctx.Debug(81, *YYCURSOR);
        if (yych == '\t') goto yy80;
        if (yych == ' ') goto yy80;
        goto yy65;
    }
/* *********************************** */
yyc_DEFCMD:
    {
        static const unsigned char yybm[] = {
              0,   0,   0,   0,   0,   0,   0,   0, 
              0, 128,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
            128,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0, 128,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
        };
        ctx.Debug(82, *YYCURSOR);
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
        if (yych <= ' ') {
            if (yych <= '\n') {
                if (yych <= 0x08) goto yy85;
                if (yych <= '\t') goto yy87;
            } else {
                if (yych == 0x1A) goto yy89;
                if (yych <= 0x1F) goto yy85;
                goto yy87;
            }
        } else {
            if (yych <= '@') {
                if (yych == ',') goto yy87;
                goto yy85;
            } else {
                if (yych <= 'Z') goto yy90;
                if (yych <= '`') goto yy85;
                if (yych <= 'z') goto yy90;
                goto yy85;
            }
        }
yy84:
        ctx.Debug(84, *YYCURSOR);
        YYCURSOR = YYMARKER;
        goto yy86;
yy85:
        ctx.Debug(85, *YYCURSOR);
        ++YYCURSOR;
yy86:
        ctx.Debug(86, *YYCURSOR);
        YYSETCONDITION(yycINITIAL);
#line 640 "lexer.cc.re"
        { YYCURSOR = ctx.buffer_begin; Return (qb64DEFINE); /* end of def */ }
#line 1097 "lexer.cc"
yy87:
        ctx.Debug(87, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy97;
yy88:
        ctx.Debug(88, *YYCURSOR);
#line 639 "lexer.cc.re"
        { /* Ignore comma and space */ ctx.Catchup();; goto yyc_DEFCMD; }
#line 1107 "lexer.cc"
yy89:
        ctx.Debug(89, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy86;
yy90:
        ctx.Debug(90, *YYCURSOR);
        yyaccept = 0;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '\'') {
            if (yych <= 0x1F) {
                if (yych <= 0x08) goto yy86;
                if (yych >= '\v') goto yy86;
            } else {
                if (yych <= ' ') goto yy91;
                if (yych <= '&') goto yy86;
            }
        } else {
            if (yych <= '-') {
                if (yych <= '+') goto yy86;
                if (yych >= '-') goto yy93;
            } else {
                if (yych <= '9') goto yy86;
                if (yych >= '<') goto yy86;
            }
        }
yy91:
        ctx.Debug(91, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(92, *YYCURSOR);
#line 635 "lexer.cc.re"
        { yylval.str += std::toupper(ctx.buffer_begin[0]);
                                  --YYCURSOR; // Discard that trailing character
                                  ctx.Catchup(); goto yyc_DEFCMD;
                                }
#line 1142 "lexer.cc"
yy93:
        ctx.Debug(93, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '@') goto yy84;
        if (yych <= 'Z') goto yy94;
        if (yych <= '`') goto yy84;
        if (yych >= '{') goto yy84;
yy94:
        ctx.Debug(94, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(95, *YYCURSOR);
#line 629 "lexer.cc.re"
        { char first = std::toupper(ctx.buffer_begin[0]);
                                  char last  = std::toupper(ctx.buffer_begin[2]);
                                  if(first > last) std::swap(first, last);
                                  for(char c=first; c<=last; ++c) yylval.str += c;
                                  ctx.Catchup(); goto yyc_DEFCMD;
                                }
#line 1161 "lexer.cc"
yy96:
        ctx.Debug(96, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy97:
        ctx.Debug(97, *YYCURSOR);
        if (yybm[0+yych] & 128) {
            goto yy96;
        }
        goto yy88;
    }
/* *********************************** */
yyc_INCLUDE:
    {
        static const unsigned char yybm[] = {
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128,   0, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128,   0, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
        };
        ctx.Debug(98, *YYCURSOR);
        if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
        yych = (unsigned char)*YYCURSOR;
        if (yych <= 0x19) {
            if (yych != '\n') goto yy101;
        } else {
            if (yych <= 0x1A) goto yy102;
            if (yych == '\'') goto yy103;
            goto yy101;
        }
yy100:
        ctx.Debug(100, *YYCURSOR);
        YYSETCONDITION(yycINITIAL);
#line 678 "lexer.cc.re"
        {
    auto s = ctx.Get(); const char* yytext = s.c_str();
    dprintf(dp_lexer, "Meta $INCLUDE: '%s'\n", yytext);

    contexts.emplace_back( std::move(ctx) );

    FILE* fp = std::fopen(yytext, "rt");
    if(!fp)
    {
        dprintf(dp_errors, "Error: unable to open include file %s", yytext);
        ctx.fp = nullptr;
        return static_cast<QBtoken>(0);
    }

    yyStartFile(fp, yytext);
  }
#line 1241 "lexer.cc"
yy101:
        ctx.Debug(101, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy106;
yy102:
        ctx.Debug(102, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy106;
yy103:
        ctx.Debug(103, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(104, *YYCURSOR);
        YYSETCONDITION(yycCOMMENT_NOTMETA);
#line 694 "lexer.cc.re"
        goto yyc_COMMENT_NOTMETA;
#line 1257 "lexer.cc"
yy105:
        ctx.Debug(105, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy106:
        ctx.Debug(106, *YYCURSOR);
        if (yybm[0+yych] & 128) {
            goto yy105;
        }
        goto yy100;
    }
/* *********************************** */
yyc_INITIAL:
    {
        static const unsigned char yybm[] = {
            /* table 1 .. 8: 0 */
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 140,   0, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            140, 128,   0, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            243, 243, 227, 227, 227, 227, 227, 227, 
            195, 195, 136, 128, 128, 128, 128, 128, 
            128, 193, 193, 193, 193, 193, 193, 129, 
            129, 129, 129, 129, 129, 129, 129, 129, 
            129, 129, 129, 129, 129, 129, 129, 129, 
            129, 129, 129, 128, 128, 128, 128, 129, 
            128, 193, 193, 193, 193, 193, 193, 129, 
            129, 129, 129, 129, 129, 129, 129, 129, 
            129, 129, 129, 129, 129, 129, 129, 129, 
            129, 129, 129, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 128, 
            /* table 9 .. 9: 256 */
              0,   0,   0,   0,   0,   0,   0,   0, 
              0, 128, 128,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
            128,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
              0,   0,   0,   0,   0,   0,   0,   0, 
        };
        ctx.Debug(107, *YYCURSOR);
        if ((YYLIMIT - YYCURSOR) < 10) YYFILL(10);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(-1, yych);
        switch (yych) {
        case '\t':
        case ' ':    goto yy111;
        case '\n':    goto yy162;
        case 0x1A:    goto yy113;
        case '!':    goto yy115;
        case '"':    goto yy116;
        case '#':    goto yy117;
        case '&':    goto yy119;
        case '\'':    goto yy120;
        case '(':    goto yy122;
        case ')':    goto yy124;
        case '*':    goto yy126;
        case '+':    goto yy128;
        case ',':    goto yy130;
        case '-':    goto yy132;
        case '.':    goto yy134;
        case '/':    goto yy136;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':    goto yy138;
        case ':':    goto yy140;
        case ';':    goto yy142;
        case '<':    goto yy144;
        case '=':    goto yy146;
        case '>':    goto yy148;
        case '?':    goto yy150;
        case 'A':
        case 'B':
        case 'C':
        case 'E':
        case 'F':
        case 'H':
        case 'I':
        case 'J':
        case 'K':
        case 'L':
        case 'M':
        case 'N':
        case 'O':
        case 'P':
        case 'Q':
        case 'S':
        case 'T':
        case 'U':
        case 'V':
        case 'W':
        case 'X':
        case 'Y':
        case 'Z':
        case 'a':
        case 'b':
        case 'c':
        case 'e':
        case 'f':
        case 'h':
        case 'i':
        case 'j':
        case 'k':
        case 'l':
        case 'm':
        case 'n':
        case 'o':
        case 'p':
        case 'q':
        case 's':
        case 't':
        case 'u':
        case 'v':
        case 'w':
        case 'x':
        case 'y':
        case 'z':    goto yy152;
        case 'D':
        case 'd':    goto yy154;
        case 'G':
        case 'g':    goto yy155;
        case 'R':
        case 'r':    goto yy156;
        case '\\':    goto yy157;
        case '^':    goto yy159;
        case '_':    goto yy161;
        default:    goto yy109;
        }
yy109:
        ctx.Debug(109, *YYCURSOR);
        ++YYCURSOR;
yy110:
        ctx.Debug(110, *YYCURSOR);
#line 701 "lexer.cc.re"
        { dprintf(dp_errors, "Unknown character: '%c'\n", YYCURSOR[-1]); goto yyc_INITIAL; }
#line 1443 "lexer.cc"
yy111:
        ctx.Debug(111, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy334;
yy112:
        ctx.Debug(112, *YYCURSOR);
#line 627 "lexer.cc.re"
        { /* blank   */ ctx.Catchup(); goto yyc_INITIAL; }
#line 1453 "lexer.cc"
yy113:
        ctx.Debug(113, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(114, *YYCURSOR);
#line 696 "lexer.cc.re"
        { // ^Z
    bool e = yyEndFile();
    if(!e) { Return (0); }
    ctx.Catchup(); goto yyc_INITIAL;
}
#line 1464 "lexer.cc"
yy115:
        ctx.Debug(115, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == '=') goto yy331;
        goto yy110;
yy116:
        ctx.Debug(116, *YYCURSOR);
        yyaccept = 0;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        goto yy328;
yy117:
        ctx.Debug(117, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy326;
yy118:
        ctx.Debug(118, *YYCURSOR);
#line 598 "lexer.cc.re"
        { Return (HASHSYM); }
#line 1484 "lexer.cc"
yy119:
        ctx.Debug(119, *YYCURSOR);
        yyaccept = 0;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= 'O') {
            if (yych <= 'G') {
                if (yych == 'B') goto yy291;
                goto yy110;
            } else {
                if (yych <= 'H') goto yy289;
                if (yych <= 'N') goto yy110;
                goto yy290;
            }
        } else {
            if (yych <= 'g') {
                if (yych == 'b') goto yy291;
                goto yy110;
            } else {
                if (yych <= 'h') goto yy289;
                if (yych == 'o') goto yy290;
                goto yy110;
            }
        }
yy120:
        ctx.Debug(120, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(121, *YYCURSOR);
        YYSETCONDITION(yycCOMMENT);
#line 506 "lexer.cc.re"
        { return(CRLF); }
#line 1515 "lexer.cc"
yy122:
        ctx.Debug(122, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy324;
yy123:
        ctx.Debug(123, *YYCURSOR);
#line 622 "lexer.cc.re"
        { Return (OPENPARENS); }
#line 1525 "lexer.cc"
yy124:
        ctx.Debug(124, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy322;
yy125:
        ctx.Debug(125, *YYCURSOR);
#line 623 "lexer.cc.re"
        { Return (CLOSEPARENS); }
#line 1535 "lexer.cc"
yy126:
        ctx.Debug(126, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy320;
yy127:
        ctx.Debug(127, *YYCURSOR);
#line 617 "lexer.cc.re"
        { Return (ASTERISK); }
#line 1545 "lexer.cc"
yy128:
        ctx.Debug(128, *YYCURSOR);
        yyaccept = 1;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '-') {
            if (yych == '&') goto yy288;
            goto yy287;
        } else {
            if (yych <= '.') goto yy283;
            if (yych <= '/') goto yy287;
            if (yych <= '9') goto yy259;
            goto yy287;
        }
yy129:
        ctx.Debug(129, *YYCURSOR);
#line 616 "lexer.cc.re"
        { Return (PLUS); }
#line 1563 "lexer.cc"
yy130:
        ctx.Debug(130, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy285;
yy131:
        ctx.Debug(131, *YYCURSOR);
#line 620 "lexer.cc.re"
        { Return (COMMA); }
#line 1573 "lexer.cc"
yy132:
        ctx.Debug(132, *YYCURSOR);
        yyaccept = 2;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == '.') goto yy283;
        if (yych <= '/') goto yy282;
        if (yych <= '9') goto yy259;
        goto yy282;
yy133:
        ctx.Debug(133, *YYCURSOR);
#line 612 "lexer.cc.re"
        { Return (MINUS); }
#line 1586 "lexer.cc"
yy134:
        ctx.Debug(134, *YYCURSOR);
        ++YYCURSOR;
        if ((yych = (unsigned char)*YYCURSOR) <= '/') goto yy274;
        if (yych <= '9') goto yy275;
        goto yy274;
yy135:
        ctx.Debug(135, *YYCURSOR);
#line 624 "lexer.cc.re"
        { Return (PERIOD); }
#line 1597 "lexer.cc"
yy136:
        ctx.Debug(136, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy272;
yy137:
        ctx.Debug(137, *YYCURSOR);
#line 618 "lexer.cc.re"
        { Return (SLASH); }
#line 1607 "lexer.cc"
yy138:
        ctx.Debug(138, *YYCURSOR);
        yyaccept = 3;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '/') {
            if (yych <= '&') {
                if (yych <= '$') goto yy256;
                if (yych <= '%') goto yy262;
                goto yy264;
            } else {
                if (yych == '.') goto yy255;
                goto yy256;
            }
        } else {
            if (yych <= '`') {
                if (yych <= '9') goto yy259;
                if (yych <= '_') goto yy256;
                goto yy265;
            } else {
                if (yych == '~') goto yy261;
                goto yy256;
            }
        }
yy139:
        ctx.Debug(139, *YYCURSOR);
#line 574 "lexer.cc.re"
        {
    auto s = ctx.Get(); const char* yytext = s.c_str();
    char*endp;
    yylval.had_sign = *yytext=='-' || *yytext=='+';
    if(*yytext=='+') ++yytext;
    yylval.number   = (strtold(yytext,&endp));
    yylval.numtype  = endp;
    if(!*endp)
    {
        yylval.numtype = "#";
        if(yylval.number == (float)yylval.number) yylval.numtype = "!";
        if(yylval.number == (long)yylval.number)  yylval.numtype = "&";
        if(yylval.number == (short)yylval.number) yylval.numtype = "%";
    }
    Return(NUMBER);
  }
#line 1650 "lexer.cc"
yy140:
        ctx.Debug(140, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy254;
yy141:
        ctx.Debug(141, *YYCURSOR);
#line 595 "lexer.cc.re"
        { Return(COLONCHAR); }
#line 1660 "lexer.cc"
yy142:
        ctx.Debug(142, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy252;
yy143:
        ctx.Debug(143, *YYCURSOR);
#line 621 "lexer.cc.re"
        { Return (SEMICOLON); }
#line 1670 "lexer.cc"
yy144:
        ctx.Debug(144, *YYCURSOR);
        ++YYCURSOR;
        if ((yych = (unsigned char)*YYCURSOR) <= '<') goto yy245;
        if (yych <= '=') goto yy248;
        if (yych <= '>') goto yy246;
        goto yy245;
yy145:
        ctx.Debug(145, *YYCURSOR);
#line 613 "lexer.cc.re"
        { Return (LESSTHAN); }
#line 1682 "lexer.cc"
yy146:
        ctx.Debug(146, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy243;
yy147:
        ctx.Debug(147, *YYCURSOR);
#line 615 "lexer.cc.re"
        { Return (EQUALS); }
#line 1692 "lexer.cc"
yy148:
        ctx.Debug(148, *YYCURSOR);
        ++YYCURSOR;
        if ((yych = (unsigned char)*YYCURSOR) <= ';') goto yy235;
        if (yych <= '<') goto yy236;
        if (yych <= '=') goto yy239;
        goto yy235;
yy149:
        ctx.Debug(149, *YYCURSOR);
#line 614 "lexer.cc.re"
        { Return (GREATERTHAN); }
#line 1704 "lexer.cc"
yy150:
        ctx.Debug(150, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(151, *YYCURSOR);
#line 593 "lexer.cc.re"
        { Return(PRINT); }
#line 1711 "lexer.cc"
yy152:
        ctx.Debug(152, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        goto yy189;
yy153:
        ctx.Debug(153, *YYCURSOR);
#line 511 "lexer.cc.re"
        { yylval.str = std::move(ctx.Get());

      auto i = ReservedWords.find(UCase(yylval.str));
      if(i != ReservedWords.end())
      {
          Return(i->second);
      }

      if( UCase(yylval.str.substr(0,2)) == "FN" )
          Return(FNIDENTIFIER);

      Return(IDENTIFIER);
    }
#line 1733 "lexer.cc"
yy154:
        ctx.Debug(154, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= 'E') {
            if (yych == 'A') goto yy207;
            if (yych <= 'D') goto yy189;
            goto yy208;
        } else {
            if (yych <= 'a') {
                if (yych <= '`') goto yy189;
                goto yy207;
            } else {
                if (yych == 'e') goto yy208;
                goto yy189;
            }
        }
yy155:
        ctx.Debug(155, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'O') goto yy201;
        if (yych == 'o') goto yy201;
        goto yy189;
yy156:
        ctx.Debug(156, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'E') goto yy190;
        if (yych == 'e') goto yy190;
        goto yy189;
yy157:
        ctx.Debug(157, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy187;
yy158:
        ctx.Debug(158, *YYCURSOR);
#line 619 "lexer.cc.re"
        { Return (BKSLASH); }
#line 1774 "lexer.cc"
yy159:
        ctx.Debug(159, *YYCURSOR);
        ++YYCURSOR;
        yych = (unsigned char)*YYCURSOR;
        goto yy185;
yy160:
        ctx.Debug(160, *YYCURSOR);
#line 625 "lexer.cc.re"
        { Return (CIRCUMFLEX); }
#line 1784 "lexer.cc"
yy161:
        ctx.Debug(161, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= 'Z') {
            if (yych <= '@') {
                if (yych <= '/') goto yy110;
                if (yych <= '9') goto yy165;
                goto yy110;
            } else {
                if (yych == 'D') goto yy167;
                goto yy165;
            }
        } else {
            if (yych <= '`') {
                if (yych == '_') goto yy165;
                goto yy110;
            } else {
                if (yych == 'd') goto yy167;
                if (yych <= 'z') goto yy165;
                goto yy110;
            }
        }
yy162:
        ctx.Debug(162, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(163, *YYCURSOR);
        if (yybm[256+yych] & 128) {
            goto yy162;
        }
        ctx.Debug(164, *YYCURSOR);
#line 596 "lexer.cc.re"
        { Return(CRLF); }
#line 1819 "lexer.cc"
yy165:
        ctx.Debug(165, *YYCURSOR);
        yyaccept = 4;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
yy166:
        ctx.Debug(166, *YYCURSOR);
        if (yybm[0+yych] & 1) {
            goto yy165;
        }
        if (yych <= '%') {
            if (yych <= '"') {
                if (yych == '!') goto yy169;
                goto yy153;
            } else {
                if (yych <= '#') goto yy169;
                if (yych <= '$') goto yy170;
                goto yy173;
            }
        } else {
            if (yych <= '`') {
                if (yych <= '&') goto yy169;
                if (yych <= '_') goto yy153;
                goto yy174;
            } else {
                if (yych == '~') goto yy171;
                goto yy153;
            }
        }
yy167:
        ctx.Debug(167, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'E') goto yy168;
        if (yych != 'e') goto yy166;
yy168:
        ctx.Debug(168, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'F') goto yy179;
        if (yych == 'f') goto yy179;
        goto yy166;
yy169:
        ctx.Debug(169, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy153;
yy170:
        ctx.Debug(170, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy153;
        if (yych <= '9') goto yy177;
        goto yy153;
yy171:
        ctx.Debug(171, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '&') {
            if (yych <= '$') goto yy172;
            if (yych <= '%') goto yy173;
            goto yy169;
        } else {
            if (yych == '`') goto yy174;
        }
yy172:
        ctx.Debug(172, *YYCURSOR);
        YYCURSOR = YYMARKER;
        if (yyaccept <= 7) {
            if (yyaccept <= 3) {
                if (yyaccept <= 1) {
                    if (yyaccept <= 0) {
                        goto yy110;
                    } else {
                        goto yy129;
                    }
                } else {
                    if (yyaccept <= 2) {
                        goto yy133;
                    } else {
                        goto yy139;
                    }
                }
            } else {
                if (yyaccept <= 5) {
                    if (yyaccept <= 4) {
                        goto yy153;
                    } else {
                        goto yy183;
                    }
                } else {
                    if (yyaccept <= 6) {
                        goto yy200;
                    } else {
                        goto yy217;
                    }
                }
            }
        } else {
            if (yyaccept <= 11) {
                if (yyaccept <= 9) {
                    if (yyaccept <= 8) {
                        goto yy219;
                    } else {
                        goto yy222;
                    }
                } else {
                    if (yyaccept <= 10) {
                        goto yy225;
                    } else {
                        goto yy228;
                    }
                }
            } else {
                if (yyaccept <= 13) {
                    if (yyaccept <= 12) {
                        goto yy231;
                    } else {
                        goto yy294;
                    }
                } else {
                    if (yyaccept <= 14) {
                        goto yy303;
                    } else {
                        goto yy312;
                    }
                }
            }
        }
yy173:
        ctx.Debug(173, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == '%') goto yy169;
        goto yy153;
yy174:
        ctx.Debug(174, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy153;
        if (yych >= ':') goto yy153;
yy175:
        ctx.Debug(175, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(176, *YYCURSOR);
        if (yybm[0+yych] & 2) {
            goto yy175;
        }
        goto yy153;
yy177:
        ctx.Debug(177, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(178, *YYCURSOR);
        if (yych <= '/') goto yy153;
        if (yych <= '9') goto yy177;
        goto yy153;
yy179:
        ctx.Debug(179, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'I') goto yy180;
        if (yych != 'i') goto yy166;
yy180:
        ctx.Debug(180, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'N') goto yy181;
        if (yych != 'n') goto yy166;
yy181:
        ctx.Debug(181, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'E') goto yy182;
        if (yych != 'e') goto yy166;
yy182:
        ctx.Debug(182, *YYCURSOR);
        yyaccept = 5;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy166;
            } else {
                if (yych <= '&') goto yy166;
                if (yych >= '0') goto yy166;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy183;
                if (yych <= 'Z') goto yy166;
            } else {
                if (yych <= 'z') goto yy166;
                if (yych == '~') goto yy166;
            }
        }
yy183:
        ctx.Debug(183, *YYCURSOR);
        YYSETCONDITION(yycDEFCMD);
#line 478 "lexer.cc.re"
        { yylval.numtype.clear(); ctx.Catchup(); yylval.str.clear(); goto yyc_DEFCMD; }
#line 2019 "lexer.cc"
yy184:
        ctx.Debug(184, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy185:
        ctx.Debug(185, *YYCURSOR);
        if (yybm[0+yych] & 4) {
            goto yy184;
        }
        goto yy160;
yy186:
        ctx.Debug(186, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy187:
        ctx.Debug(187, *YYCURSOR);
        if (yych == '\t') goto yy186;
        if (yych == ' ') goto yy186;
        goto yy158;
yy188:
        ctx.Debug(188, *YYCURSOR);
        yyaccept = 4;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
yy189:
        ctx.Debug(189, *YYCURSOR);
        if (yych <= '9') {
            if (yych <= '#') {
                if (yych == '!') goto yy169;
                if (yych <= '"') goto yy153;
                goto yy169;
            } else {
                if (yych <= '%') {
                    if (yych <= '$') goto yy191;
                    goto yy193;
                } else {
                    if (yych <= '&') goto yy169;
                    if (yych <= '/') goto yy153;
                    goto yy188;
                }
            }
        } else {
            if (yych <= '_') {
                if (yych <= '@') goto yy153;
                if (yych <= 'Z') goto yy188;
                if (yych <= '^') goto yy153;
                goto yy188;
            } else {
                if (yych <= 'z') {
                    if (yych <= '`') goto yy194;
                    goto yy188;
                } else {
                    if (yych == '~') goto yy192;
                    goto yy153;
                }
            }
        }
yy190:
        ctx.Debug(190, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'M') goto yy199;
        if (yych == 'm') goto yy199;
        goto yy189;
yy191:
        ctx.Debug(191, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy153;
        if (yych <= '9') goto yy197;
        goto yy153;
yy192:
        ctx.Debug(192, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '&') {
            if (yych <= '$') goto yy172;
            if (yych >= '&') goto yy169;
        } else {
            if (yych == '`') goto yy194;
            goto yy172;
        }
yy193:
        ctx.Debug(193, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == '%') goto yy169;
        goto yy153;
yy194:
        ctx.Debug(194, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy153;
        if (yych >= ':') goto yy153;
yy195:
        ctx.Debug(195, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(196, *YYCURSOR);
        if (yych <= '/') goto yy153;
        if (yych <= '9') goto yy195;
        goto yy153;
yy197:
        ctx.Debug(197, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(198, *YYCURSOR);
        if (yych <= '/') goto yy153;
        if (yych <= '9') goto yy197;
        goto yy153;
yy199:
        ctx.Debug(199, *YYCURSOR);
        yyaccept = 6;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy189;
            } else {
                if (yych <= '&') goto yy189;
                if (yych >= '0') goto yy189;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy200;
                if (yych <= 'Z') goto yy189;
            } else {
                if (yych <= 'z') goto yy189;
                if (yych == '~') goto yy189;
            }
        }
yy200:
        ctx.Debug(200, *YYCURSOR);
        YYSETCONDITION(yycCOMMENT);
#line 484 "lexer.cc.re"
        {
                      #ifdef LEXER_DEBUG
                        dprintf(dp_lexer, "REM acquired. Prev_return = %s\n", GetTokenName(prev_return).c_str());
                      #endif
                        if(prev_return == THEN || prev_return == ELSE)
                        {
                            // If REM follows a THEN or ELSE, it is treated as a statement.
                            // This means that "IF 0 THEN REM xx" is a shortif, not a longif.
                            Return(REM);
                        }
                        if(prev_return != COLONCHAR
                        && prev_return != CRLF
                        && prev_return != NUMBER)
                        {
                            dprintf(dp_errors, "Error: Unexpected REM\n");
                            YYSETCONDITION(yycINITIAL);
                            Return(REM);
                        }
                        /* REM starts a comment only when at statement boundary */
                        /* REM always ends in a CRLF, so return the CRLF now.   */
                        return CRLF;
                      }
#line 2177 "lexer.cc"
yy201:
        ctx.Debug(201, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '&') {
            if (yych <= '!') {
                if (yych <= '\t') {
                    if (yych <= 0x08) goto yy153;
                } else {
                    if (yych <= 0x1F) goto yy153;
                    if (yych >= '!') goto yy169;
                }
            } else {
                if (yych <= '#') {
                    if (yych <= '"') goto yy153;
                    goto yy169;
                } else {
                    if (yych <= '$') goto yy191;
                    if (yych <= '%') goto yy193;
                    goto yy169;
                }
            }
        } else {
            if (yych <= '^') {
                if (yych <= '9') {
                    if (yych <= '/') goto yy153;
                    goto yy188;
                } else {
                    if (yych <= '@') goto yy153;
                    if (yych <= 'Z') goto yy188;
                    goto yy153;
                }
            } else {
                if (yych <= 'z') {
                    if (yych == '`') goto yy194;
                    goto yy188;
                } else {
                    if (yych == '~') goto yy192;
                    goto yy153;
                }
            }
        }
yy202:
        ctx.Debug(202, *YYCURSOR);
        ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(203, *YYCURSOR);
        if (yych <= ' ') {
            if (yych == '\t') goto yy202;
            if (yych <= 0x1F) goto yy172;
            goto yy202;
        } else {
            if (yych <= 'T') {
                if (yych <= 'S') goto yy172;
            } else {
                if (yych != 't') goto yy172;
            }
        }
        ctx.Debug(204, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych == 'O') goto yy205;
        if (yych != 'o') goto yy172;
yy205:
        ctx.Debug(205, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(206, *YYCURSOR);
#line 592 "lexer.cc.re"
        { Return(GOTO); }
#line 2247 "lexer.cc"
yy207:
        ctx.Debug(207, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'T') goto yy229;
        if (yych == 't') goto yy229;
        goto yy189;
yy208:
        ctx.Debug(208, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'F') goto yy209;
        if (yych != 'f') goto yy189;
yy209:
        ctx.Debug(209, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= 'S') {
            if (yych <= 'I') {
                if (yych == 'D') goto yy210;
                if (yych <= 'H') goto yy189;
                goto yy211;
            } else {
                if (yych == 'L') goto yy212;
                if (yych <= 'R') goto yy189;
                goto yy213;
            }
        } else {
            if (yych <= 'i') {
                if (yych == 'd') goto yy210;
                if (yych <= 'h') goto yy189;
                goto yy211;
            } else {
                if (yych <= 'l') {
                    if (yych <= 'k') goto yy189;
                    goto yy212;
                } else {
                    if (yych == 's') goto yy213;
                    goto yy189;
                }
            }
        }
yy210:
        ctx.Debug(210, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'B') goto yy226;
        if (yych == 'b') goto yy226;
        goto yy189;
yy211:
        ctx.Debug(211, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'N') goto yy223;
        if (yych == 'n') goto yy223;
        goto yy189;
yy212:
        ctx.Debug(212, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'N') goto yy220;
        if (yych == 'n') goto yy220;
        goto yy189;
yy213:
        ctx.Debug(213, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= 'T') {
            if (yych == 'N') goto yy214;
            if (yych <= 'S') goto yy189;
            goto yy215;
        } else {
            if (yych <= 'n') {
                if (yych <= 'm') goto yy189;
            } else {
                if (yych == 't') goto yy215;
                goto yy189;
            }
        }
yy214:
        ctx.Debug(214, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'G') goto yy218;
        if (yych == 'g') goto yy218;
        goto yy189;
yy215:
        ctx.Debug(215, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'R') goto yy216;
        if (yych != 'r') goto yy189;
yy216:
        ctx.Debug(216, *YYCURSOR);
        yyaccept = 7;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy189;
            } else {
                if (yych <= '&') goto yy189;
                if (yych >= '0') goto yy189;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy217;
                if (yych <= 'Z') goto yy189;
            } else {
                if (yych <= 'z') goto yy189;
                if (yych == '~') goto yy189;
            }
        }
yy217:
        ctx.Debug(217, *YYCURSOR);
        YYSETCONDITION(yycDEFCMD);
#line 476 "lexer.cc.re"
        { yylval.numtype = "$"; ctx.Catchup(); yylval.str.clear(); goto yyc_DEFCMD; }
#line 2365 "lexer.cc"
yy218:
        ctx.Debug(218, *YYCURSOR);
        yyaccept = 8;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy189;
            } else {
                if (yych <= '&') goto yy189;
                if (yych >= '0') goto yy189;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy219;
                if (yych <= 'Z') goto yy189;
            } else {
                if (yych <= 'z') goto yy189;
                if (yych == '~') goto yy189;
            }
        }
yy219:
        ctx.Debug(219, *YYCURSOR);
        YYSETCONDITION(yycDEFCMD);
#line 474 "lexer.cc.re"
        { yylval.numtype = "!"; ctx.Catchup(); yylval.str.clear(); goto yyc_DEFCMD; }
#line 2391 "lexer.cc"
yy220:
        ctx.Debug(220, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'G') goto yy221;
        if (yych != 'g') goto yy189;
yy221:
        ctx.Debug(221, *YYCURSOR);
        yyaccept = 9;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy189;
            } else {
                if (yych <= '&') goto yy189;
                if (yych >= '0') goto yy189;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy222;
                if (yych <= 'Z') goto yy189;
            } else {
                if (yych <= 'z') goto yy189;
                if (yych == '~') goto yy189;
            }
        }
yy222:
        ctx.Debug(222, *YYCURSOR);
        YYSETCONDITION(yycDEFCMD);
#line 477 "lexer.cc.re"
        { yylval.numtype = "&"; ctx.Catchup(); yylval.str.clear(); goto yyc_DEFCMD; }
#line 2423 "lexer.cc"
yy223:
        ctx.Debug(223, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'T') goto yy224;
        if (yych != 't') goto yy189;
yy224:
        ctx.Debug(224, *YYCURSOR);
        yyaccept = 10;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy189;
            } else {
                if (yych <= '&') goto yy189;
                if (yych >= '0') goto yy189;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy225;
                if (yych <= 'Z') goto yy189;
            } else {
                if (yych <= 'z') goto yy189;
                if (yych == '~') goto yy189;
            }
        }
yy225:
        ctx.Debug(225, *YYCURSOR);
        YYSETCONDITION(yycDEFCMD);
#line 473 "lexer.cc.re"
        { yylval.numtype = "%"; ctx.Catchup(); yylval.str.clear(); goto yyc_DEFCMD; }
#line 2455 "lexer.cc"
yy226:
        ctx.Debug(226, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'L') goto yy227;
        if (yych != 'l') goto yy189;
yy227:
        ctx.Debug(227, *YYCURSOR);
        yyaccept = 11;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '"') {
                if (yych == '!') goto yy189;
            } else {
                if (yych <= '&') goto yy189;
                if (yych >= '0') goto yy189;
            }
        } else {
            if (yych <= '^') {
                if (yych <= '@') goto yy228;
                if (yych <= 'Z') goto yy189;
            } else {
                if (yych <= 'z') goto yy189;
                if (yych == '~') goto yy189;
            }
        }
yy228:
        ctx.Debug(228, *YYCURSOR);
        YYSETCONDITION(yycDEFCMD);
#line 475 "lexer.cc.re"
        { yylval.numtype = "#"; ctx.Catchup(); yylval.str.clear(); goto yyc_DEFCMD; }
#line 2487 "lexer.cc"
yy229:
        ctx.Debug(229, *YYCURSOR);
        yyaccept = 4;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych == 'A') goto yy230;
        if (yych != 'a') goto yy189;
yy230:
        ctx.Debug(230, *YYCURSOR);
        yyaccept = 12;
        yych = (unsigned char)*(YYMARKER = ++YYCURSOR);
        if (yych <= '9') {
            if (yych <= '#') {
                if (yych == '!') goto yy169;
                if (yych <= '"') goto yy233;
                goto yy169;
            } else {
                if (yych <= '%') {
                    if (yych <= '$') goto yy191;
                    goto yy193;
                } else {
                    if (yych <= '&') goto yy169;
                    if (yych <= '/') goto yy233;
                    goto yy188;
                }
            }
        } else {
            if (yych <= '_') {
                if (yych <= '@') goto yy233;
                if (yych <= 'Z') goto yy188;
                if (yych <= '^') goto yy233;
                goto yy188;
            } else {
                if (yych <= 'z') {
                    if (yych <= '`') goto yy194;
                    goto yy188;
                } else {
                    if (yych == '~') goto yy192;
                    goto yy233;
                }
            }
        }
yy231:
        ctx.Debug(231, *YYCURSOR);
        YYSETCONDITION(yycDATA);
#line 481 "lexer.cc.re"
        { Return(DATA); }
#line 2534 "lexer.cc"
yy232:
        ctx.Debug(232, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy233:
        ctx.Debug(233, *YYCURSOR);
        if (yych == '\t') goto yy232;
        if (yych == ' ') goto yy232;
        goto yy231;
yy234:
        ctx.Debug(234, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy235:
        ctx.Debug(235, *YYCURSOR);
        if (yych == '\t') goto yy234;
        if (yych == ' ') goto yy234;
        goto yy149;
yy236:
        ctx.Debug(236, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(237, *YYCURSOR);
        if (yych == '\t') goto yy236;
        if (yych == ' ') goto yy236;
yy238:
        ctx.Debug(238, *YYCURSOR);
#line 603 "lexer.cc.re"
        { Return (NOTEQUAL); }
#line 2567 "lexer.cc"
yy239:
        ctx.Debug(239, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(240, *YYCURSOR);
        if (yych == '\t') goto yy239;
        if (yych == ' ') goto yy239;
        ctx.Debug(241, *YYCURSOR);
#line 600 "lexer.cc.re"
        { Return (GREATEROREQUAL); }
#line 2579 "lexer.cc"
yy242:
        ctx.Debug(242, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy243:
        ctx.Debug(243, *YYCURSOR);
        if (yych == '\t') goto yy242;
        if (yych == ' ') goto yy242;
        goto yy147;
yy244:
        ctx.Debug(244, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy245:
        ctx.Debug(245, *YYCURSOR);
        if (yych == '\t') goto yy244;
        if (yych == ' ') goto yy244;
        goto yy145;
yy246:
        ctx.Debug(246, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(247, *YYCURSOR);
        if (yych == '\t') goto yy246;
        if (yych == ' ') goto yy246;
        goto yy238;
yy248:
        ctx.Debug(248, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(249, *YYCURSOR);
        if (yych == '\t') goto yy248;
        if (yych == ' ') goto yy248;
        ctx.Debug(250, *YYCURSOR);
#line 599 "lexer.cc.re"
        { Return (LESSOREQUAL); }
#line 2620 "lexer.cc"
yy251:
        ctx.Debug(251, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy252:
        ctx.Debug(252, *YYCURSOR);
        if (yych == '\t') goto yy251;
        if (yych == ' ') goto yy251;
        goto yy143;
yy253:
        ctx.Debug(253, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy254:
        ctx.Debug(254, *YYCURSOR);
        if (yybm[0+yych] & 8) {
            goto yy253;
        }
        goto yy141;
yy255:
        ctx.Debug(255, *YYCURSOR);
        yyaccept = 3;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
yy256:
        ctx.Debug(256, *YYCURSOR);
        if (yych <= '/') {
            if (yych <= '!') {
                if (yych <= ' ') goto yy139;
                goto yy258;
            } else {
                if (yych == '#') goto yy258;
                goto yy139;
            }
        } else {
            if (yych <= 'E') {
                if (yych <= '9') goto yy255;
                if (yych <= 'D') goto yy139;
            } else {
                if (yych != 'e') goto yy139;
            }
        }
yy257:
        ctx.Debug(257, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= ',') {
            if (yych == '+') goto yy268;
            goto yy172;
        } else {
            if (yych <= '-') goto yy268;
            if (yych <= '/') goto yy172;
            if (yych <= '9') goto yy269;
            goto yy172;
        }
yy258:
        ctx.Debug(258, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy139;
yy259:
        ctx.Debug(259, *YYCURSOR);
        yyaccept = 3;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(260, *YYCURSOR);
        if (yych <= '/') {
            if (yych <= '$') {
                if (yych <= '!') {
                    if (yych <= ' ') goto yy139;
                    goto yy258;
                } else {
                    if (yych == '#') goto yy258;
                    goto yy139;
                }
            } else {
                if (yych <= '&') {
                    if (yych <= '%') goto yy262;
                    goto yy264;
                } else {
                    if (yych == '.') goto yy255;
                    goto yy139;
                }
            }
        } else {
            if (yych <= '`') {
                if (yych <= 'D') {
                    if (yych <= '9') goto yy259;
                    goto yy139;
                } else {
                    if (yych <= 'E') goto yy257;
                    if (yych <= '_') goto yy139;
                    goto yy265;
                }
            } else {
                if (yych <= 'e') {
                    if (yych <= 'd') goto yy139;
                    goto yy257;
                } else {
                    if (yych != '~') goto yy139;
                }
            }
        }
yy261:
        ctx.Debug(261, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '&') {
            if (yych <= '$') goto yy172;
            if (yych >= '&') goto yy264;
        } else {
            if (yych == '`') goto yy265;
            goto yy172;
        }
yy262:
        ctx.Debug(262, *YYCURSOR);
        ++YYCURSOR;
        if ((yych = (unsigned char)*YYCURSOR) == '%') goto yy264;
yy263:
        ctx.Debug(263, *YYCURSOR);
#line 525 "lexer.cc.re"
        {
    //fprintf(stderr, "Integer: '%s'\n", yytext);
    auto s = ctx.Get(); const char* yytext = s.c_str();
    char *endp;
    yylval.had_sign = *yytext=='-' || *yytext=='+';
    if(*yytext=='+') ++yytext;

    yylval.number  = (strtoll(yytext,&endp,10));
    yylval.numtype = endp;
    Return(NUMBER);
  }
#line 2754 "lexer.cc"
yy264:
        ctx.Debug(264, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy263;
yy265:
        ctx.Debug(265, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy263;
        if (yych >= ':') goto yy263;
yy266:
        ctx.Debug(266, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(267, *YYCURSOR);
        if (yych <= '/') goto yy263;
        if (yych <= '9') goto yy266;
        goto yy263;
yy268:
        ctx.Debug(268, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '/') goto yy172;
        if (yych >= ':') goto yy172;
yy269:
        ctx.Debug(269, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(270, *YYCURSOR);
        if (yych <= '"') {
            if (yych == '!') goto yy258;
            goto yy139;
        } else {
            if (yych <= '#') goto yy258;
            if (yych <= '/') goto yy139;
            if (yych <= '9') goto yy269;
            goto yy139;
        }
yy271:
        ctx.Debug(271, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy272:
        ctx.Debug(272, *YYCURSOR);
        if (yych == '\t') goto yy271;
        if (yych == ' ') goto yy271;
        goto yy137;
yy273:
        ctx.Debug(273, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy274:
        ctx.Debug(274, *YYCURSOR);
        if (yych == '\t') goto yy273;
        if (yych == ' ') goto yy273;
        goto yy135;
yy275:
        ctx.Debug(275, *YYCURSOR);
        yyaccept = 3;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(276, *YYCURSOR);
        if (yych <= '/') {
            if (yych <= '!') {
                if (yych <= ' ') goto yy139;
                goto yy258;
            } else {
                if (yych == '#') goto yy258;
                goto yy139;
            }
        } else {
            if (yych <= 'E') {
                if (yych <= '9') goto yy275;
                if (yych <= 'D') goto yy139;
            } else {
                if (yych != 'e') goto yy139;
            }
        }
        ctx.Debug(277, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= ',') {
            if (yych != '+') goto yy172;
        } else {
            if (yych <= '-') goto yy278;
            if (yych <= '/') goto yy172;
            if (yych <= '9') goto yy279;
            goto yy172;
        }
yy278:
        ctx.Debug(278, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '/') goto yy172;
        if (yych >= ':') goto yy172;
yy279:
        ctx.Debug(279, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(280, *YYCURSOR);
        if (yych <= '"') {
            if (yych == '!') goto yy258;
            goto yy139;
        } else {
            if (yych <= '#') goto yy258;
            if (yych <= '/') goto yy139;
            if (yych <= '9') goto yy279;
            goto yy139;
        }
yy281:
        ctx.Debug(281, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy282:
        ctx.Debug(282, *YYCURSOR);
        if (yych == '\t') goto yy281;
        if (yych == ' ') goto yy281;
        goto yy133;
yy283:
        ctx.Debug(283, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '/') goto yy172;
        if (yych <= '9') goto yy275;
        goto yy172;
yy284:
        ctx.Debug(284, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy285:
        ctx.Debug(285, *YYCURSOR);
        if (yych == '\t') goto yy284;
        if (yych == ' ') goto yy284;
        goto yy131;
yy286:
        ctx.Debug(286, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy287:
        ctx.Debug(287, *YYCURSOR);
        if (yych == '\t') goto yy286;
        if (yych == ' ') goto yy286;
        goto yy129;
yy288:
        ctx.Debug(288, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= 'O') {
            if (yych <= 'G') {
                if (yych == 'B') goto yy291;
                goto yy172;
            } else {
                if (yych <= 'H') goto yy289;
                if (yych <= 'N') goto yy172;
                goto yy290;
            }
        } else {
            if (yych <= 'g') {
                if (yych == 'b') goto yy291;
                goto yy172;
            } else {
                if (yych <= 'h') goto yy289;
                if (yych == 'o') goto yy290;
                goto yy172;
            }
        }
yy289:
        ctx.Debug(289, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yybm[0+yych] & 64) {
            goto yy310;
        }
        goto yy172;
yy290:
        ctx.Debug(290, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yybm[0+yych] & 32) {
            goto yy301;
        }
        goto yy172;
yy291:
        ctx.Debug(291, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yybm[0+yych] & 16) {
            goto yy292;
        }
        goto yy172;
yy292:
        ctx.Debug(292, *YYCURSOR);
        yyaccept = 13;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(293, *YYCURSOR);
        if (yybm[0+yych] & 16) {
            goto yy292;
        }
        if (yych <= '_') {
            if (yych <= '$') goto yy294;
            if (yych <= '%') goto yy296;
            if (yych <= '&') goto yy297;
        } else {
            if (yych <= '`') goto yy298;
            if (yych == '~') goto yy295;
        }
yy294:
        ctx.Debug(294, *YYCURSOR);
#line 561 "lexer.cc.re"
        {
    //fprintf(stderr, "Binary integer: '%s'\n", yytext);
    auto s = ctx.Get(); const char* yytext = s.c_str();
    yylval.had_sign = *yytext=='+';
    if(*yytext=='+') ++yytext;
    char*endp;
    yylval.number  = (strtoll(yytext+2,&endp,2));
    yylval.numtype = *endp ? endp : "%";
    //fprintf(stderr, "-> %Lg\n", yylval.number);
    Return(NUMBER);
  }
#line 2977 "lexer.cc"
yy295:
        ctx.Debug(295, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '&') {
            if (yych <= '$') goto yy172;
            if (yych >= '&') goto yy297;
        } else {
            if (yych == '`') goto yy298;
            goto yy172;
        }
yy296:
        ctx.Debug(296, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych != '%') goto yy294;
yy297:
        ctx.Debug(297, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy294;
yy298:
        ctx.Debug(298, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy294;
        if (yych >= ':') goto yy294;
yy299:
        ctx.Debug(299, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(300, *YYCURSOR);
        if (yych <= '/') goto yy294;
        if (yych <= '9') goto yy299;
        goto yy294;
yy301:
        ctx.Debug(301, *YYCURSOR);
        yyaccept = 14;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(302, *YYCURSOR);
        if (yybm[0+yych] & 32) {
            goto yy301;
        }
        if (yych <= '_') {
            if (yych <= '$') goto yy303;
            if (yych <= '%') goto yy305;
            if (yych <= '&') goto yy306;
        } else {
            if (yych <= '`') goto yy307;
            if (yych == '~') goto yy304;
        }
yy303:
        ctx.Debug(303, *YYCURSOR);
#line 549 "lexer.cc.re"
        {
    //fprintf(stderr, "Octal integer: '%s'\n", yytext);
    auto s = ctx.Get(); const char* yytext = s.c_str();
    yylval.had_sign = *yytext=='+';
    if(*yytext=='+') ++yytext;
    char*endp;
    yylval.number  = (strtoll(yytext+2,&endp,8));
    yylval.numtype = *endp ? endp : "%";
    //fprintf(stderr, "-> %Lg\n", yylval.number);
    Return(NUMBER);
  }
#line 3042 "lexer.cc"
yy304:
        ctx.Debug(304, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '&') {
            if (yych <= '$') goto yy172;
            if (yych >= '&') goto yy306;
        } else {
            if (yych == '`') goto yy307;
            goto yy172;
        }
yy305:
        ctx.Debug(305, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych != '%') goto yy303;
yy306:
        ctx.Debug(306, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy303;
yy307:
        ctx.Debug(307, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy303;
        if (yych >= ':') goto yy303;
yy308:
        ctx.Debug(308, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(309, *YYCURSOR);
        if (yych <= '/') goto yy303;
        if (yych <= '9') goto yy308;
        goto yy303;
yy310:
        ctx.Debug(310, *YYCURSOR);
        yyaccept = 15;
        YYMARKER = ++YYCURSOR;
        if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(311, *YYCURSOR);
        if (yybm[0+yych] & 64) {
            goto yy310;
        }
        if (yych <= '_') {
            if (yych <= '$') goto yy312;
            if (yych <= '%') goto yy314;
            if (yych <= '&') goto yy315;
        } else {
            if (yych <= '`') goto yy316;
            if (yych == '~') goto yy313;
        }
yy312:
        ctx.Debug(312, *YYCURSOR);
#line 537 "lexer.cc.re"
        {
    //fprintf(stderr, "Hex integer: '%s'\n", yytext);
    auto s = ctx.Get(); const char* yytext = s.c_str();
    yylval.had_sign = *yytext=='+';
    if(*yytext=='+') ++yytext;
    char*endp;
    yylval.number  = (strtoll(yytext+2,&endp,16));
    yylval.numtype = *endp ? endp : "%";
    //fprintf(stderr, "-> %Lg\n", yylval.number);
    Return(NUMBER);
  }
#line 3107 "lexer.cc"
yy313:
        ctx.Debug(313, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '&') {
            if (yych <= '$') goto yy172;
            if (yych >= '&') goto yy315;
        } else {
            if (yych == '`') goto yy316;
            goto yy172;
        }
yy314:
        ctx.Debug(314, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych != '%') goto yy312;
yy315:
        ctx.Debug(315, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        goto yy312;
yy316:
        ctx.Debug(316, *YYCURSOR);
        yych = (unsigned char)*++YYCURSOR;
        if (yych <= '0') goto yy312;
        if (yych >= ':') goto yy312;
yy317:
        ctx.Debug(317, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(318, *YYCURSOR);
        if (yych <= '/') goto yy312;
        if (yych <= '9') goto yy317;
        goto yy312;
yy319:
        ctx.Debug(319, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy320:
        ctx.Debug(320, *YYCURSOR);
        if (yych == '\t') goto yy319;
        if (yych == ' ') goto yy319;
        goto yy127;
yy321:
        ctx.Debug(321, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy322:
        ctx.Debug(322, *YYCURSOR);
        if (yych == '\t') goto yy321;
        if (yych == ' ') goto yy321;
        goto yy125;
yy323:
        ctx.Debug(323, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy324:
        ctx.Debug(324, *YYCURSOR);
        if (yych == '\t') goto yy323;
        if (yych == ' ') goto yy323;
        goto yy123;
yy325:
        ctx.Debug(325, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy326:
        ctx.Debug(326, *YYCURSOR);
        if (yych == '\t') goto yy325;
        if (yych == ' ') goto yy325;
        goto yy118;
yy327:
        ctx.Debug(327, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy328:
        ctx.Debug(328, *YYCURSOR);
        if (yybm[0+yych] & 128) {
            goto yy327;
        }
        ctx.Debug(329, *YYCURSOR);
        ++YYCURSOR;
        ctx.Debug(330, *YYCURSOR);
#line 605 "lexer.cc.re"
        {
    yylval.str = ctx.Get(1,1); // Skip '#' and remove '"'
    //fprintf(stderr, "String: '%s'\n", yylval.str.c_str());
    if(YYCURSOR[-1] == '\n') --YYCURSOR; // unput linefeed
    Return (STRINGCONST);
  }
#line 3200 "lexer.cc"
yy331:
        ctx.Debug(331, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
        ctx.Debug(332, *YYCURSOR);
        if (yych == '\t') goto yy331;
        if (yych == ' ') goto yy331;
        goto yy238;
yy333:
        ctx.Debug(333, *YYCURSOR);
        ++YYCURSOR;
        if (YYLIMIT <= YYCURSOR) YYFILL(1);
        yych = (unsigned char)*YYCURSOR;
yy334:
        ctx.Debug(334, *YYCURSOR);
        if (yych == '\t') goto yy333;
        if (yych == ' ') goto yy333;
        goto yy112;
    }
}
#line 702 "lexer.cc.re"


CheckReturn:
    auto i = ComboTokens.find(prev_return);
    if(i == ComboTokens.end())
        return prev_return;

    LexerResult first_result = std::move(yylval);
    QBtoken first_token  = prev_return;
    QBtoken second_token = LexerGetToken();
    auto j = i->second.find(second_token);
    if(j != i->second.end())
        return j->second;

    // Oops. Wasn't a combo. Now we have two tokens.
    // Let's put the second one pending, and return the first one.
    token_pending = true;
    pending.first  = std::move(yylval);
    pending.second = second_token;

    yylval = std::move(first_result);
    return first_token;
}
