#ifndef bqtQBlibGosubHH
#define bqtQBlibGosubHH

#include <vector>

/* NOTE: This relies on a GNU extension.
 *
 * There is a way to do this with switch-cases, but there would be restrictions:
 *     - You could not nest switch-cases.
 */

extern std::vector<void*> GosubStack; // used by B_CLEAR() in exec.cc

// Note: B_GOSUB_Push is required by ON..GOSUB. B_GOSUB_Pop() is not, though.

void B_GOSUB_Push(void* label);
void* B_GOSUB_Pop();

#define B_GOSUB(label, return_label) do { B_GOSUB_Push(&&return_label); goto label; } while(0)

#define B_RETURN()         { goto* (B_GOSUB_Pop());     }
#define B_RETURN_TO(label) { B_GOSUB_Pop(); goto label; }

#endif
