#ifndef bqtQBlibPlayHH
#define bqtQBlibPlayHH

#include "types.hh"

extern void* PlayHandler;
extern int   PlayThreshold;

extern void B_StmtPLAY(const std::string& pattern);
extern void B_StmtPLAY(const std::string& pattern, const std::string& p2);
extern void B_StmtPLAY(const std::string& pattern, const std::string& p2, const std::string& p3);

extern void B_StmtPLAY(int mode);

extern int  B_FuncPLAY();

extern void B_Stmtqb64SNDRAW(double left, double right, long handle);
static inline void B_Stmtqb64SNDRAW(double left, double right) { B_Stmtqb64SNDRAW(left,right,-1); }
static inline void B_Stmtqb64SNDRAW(double left)               { B_Stmtqb64SNDRAW(left, left,-1); }

static inline int B_FuncPLAY(int) { return B_FuncPLAY(); }

extern "C" {

extern void B_StmtSOUND(int freq, int duration/*PIT ticks*/);
extern void B_StmtNOISE(int mode/*0..7*/, int volume/*0..15*/, int duration/*PIT ticks*/);
/* Noise modes: 0..3 = periodic noise
 *              4..7 = white noise
 *              0,4: pitch = something
 *              1,5: pitch = something*2
 *              2,6: pitch = something*4
 *              3,7: pitch = playchannel[2].pitch
 */
/* BEEP, SOUND and PLAY are mutually exclusive. NOISE can be layered over any. */

#define ON_PLAY_GOSUB(n,label)  do { PlayThreshold = (n); PlayHandler = &&label; } while(0)
#define ON_PLAY_GOSUB_NOWHERE() PlayHandler = nullptr

extern void      B_Stmtqb64SNDRAWOPEN(BAS_LNG handle);
extern double    B_Funcqb64SNDRAWLEN(); // in seconds
extern BAS_ULONG B_Funcqb64SNDRATE();

/* Used by ioemu.cc: */
extern void B_AdlibOut(unsigned portindex/*0..3*/, unsigned value);
extern unsigned char B_AdlibIn(unsigned portindex);

} // extern "C"

#endif
